/* MeteoArpav v 0.2.1 (c) Vanni Brutto 2006 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.Connector;

import java.util.Calendar;
import java.util.Date;
import java.io.IOException;
import java.io.DataInputStream;
import java.util.Vector;



public class MeteoArpav extends MIDlet 
                        implements CommandListener, Runnable {

    /* Classe contente i dati del giorno */
    public class Giorno {
        public String giorno;
        public String img;
        byte[] img_data;
        public String previsione;
    }

    /* Costanti */
    private String TITLE = "MeteoArpav";
    private String VERSION = "0.2.1";
    private String AUTHOR = "Vanni Brutto";

    /* Display del MIDLET */
    private Display display;

    /* Finestra Splash */
    private Form frmSplash;
    private Command btnExitSplash;
    private Command btnShowMain;

    /* Finestra principale di scelta giorno */
    private Form frmMain;
    private StringItem lblCopyright;
    private ChoiceGroup choiceGiorni; 
    private StringItem lblEmissione;
    private Command btnExitMain;
    private Command btnPrevisioni; 

    /* Finestra con previsione del giorno */
    private Form frmPrevisioni;
    private StringItem lblPrevisione;
    private Command btnViewImage;
    private Command btnBackMain;

    /* Finestra con immagine previsione */
    private Form frmImage;
    private Command btnBackPrevisioni;

    private boolean boolViewImage;
    private Calendar calendar;
    private ImageItem imgItem;
    private int indImgItem;
    private int netState;
    
    private String PREVISIONE = "Previsione:\n";

    private Thread thread;

    /* File dell'immagine */
    private String aaaammggImage;

    /* Data di oggi in formato AAAAMMGG */
    private String aaaammggOggi;

    /* Data del bollettino della pagina */
    private String aaaammggWeb;

    /* Data emissione del bollettino (in formato "parlante") */
    private String dataEmissione;

    /* Comodi */
    private String getUrl;
    private String getUrlImage;
    private String giornoSelezionato;

    /* Array di giorni */
    private Giorno[] giorniArray = new Giorno[6];

    public void run() {
        if (netState == 1) {
            if (getPrevisioneFromUrl(getUrl)) {
                makeFrmMain();
                popolaGiorni();
                showFrmMain();
            } else {
                frmSplash.addCommand(btnShowMain);
            }
        }
        if (netState == 2) {
            for (int i = 0; i < giorniArray.length; i++) {
                if (giorniArray[i] == null) break;
                if (giorniArray[i].giorno.equals(giornoSelezionato)) {
                    if (giorniArray[i].img_data == null) {
                        byte[] data = getImageFromUrl(getUrlImage);
                        giorniArray[i].img_data = data;
                        imgItem.setImage(Image.createImage(data,
                                                           0,
                                                           data.length));
                    } else
                        imgItem.setImage(Image.createImage(giorniArray[i].img_data,
                                                           0,
                                                           giorniArray[i].img_data.length));
                }
            }

            showFrmImage();
        }
    }

    public MeteoArpav() {
        display = Display.getDisplay(this);
        makeFrmSplash();
        makeFrmPrevisioni();
        makeFrmImage();
        showFrmSplash();

    }

    public String get_from_string(String inputString, String matchString) {
        StringBuffer n = new StringBuffer();

        int posStart = inputString.indexOf("_"+matchString);
        int posEnd = inputString.indexOf(matchString+"_");
        
        if ((posStart >= 0) && (posEnd >= 0)) {
            int lngPattern = matchString.length()+1;
            n.append(inputString.substring(posStart+lngPattern, posEnd));
        }

        return n.toString(); 
    }

    public boolean parseDataFromServer(String data) {
        String[] dataArray = split(data, "\n");
        int j = -1;

        for (int i = 0; i < dataArray.length; i++) {
            String DATE = get_from_string(dataArray[i], "DATE");
            String DATEN = get_from_string(dataArray[i], "DATEN");
            String DAY = get_from_string(dataArray[i], "DAY");
            String IMG = get_from_string(dataArray[i], "IMG");

            if (DATE.length() > 0) {
                dataEmissione = DATE;
            } else if (DATEN.length() > 0) {
                aaaammggWeb = DATEN;
            } else if (DAY.length() > 0) {
                j++;
                giorniArray[j] = new Giorno();
                giorniArray[j].giorno = DAY;
            } else if (IMG.length() > 0)
                giorniArray[j].img = IMG;
              else {
                /* Se j vale -1 c' qualcosa che non va! :( */
                if (j == -1) return false;
                if (giorniArray[j].previsione != null)
                    giorniArray[j].previsione = giorniArray[j].previsione + dataArray[i] + "\n";
                else
                    giorniArray[j].previsione = dataArray[i] + "\n";
              }
        }

        return true;
    }

    private String[] split(String original, String separator) {
        Vector nodes = new Vector();
     
        // Parse nodes into vector
        int index = original.indexOf(separator);
        while (index >= 0) {
            nodes.addElement(original.substring(0, index));
            original = original.substring(index+separator.length());
            index = original.indexOf(separator);
        }
        // Get the last node
        nodes.addElement(original);
     
        // Create splitted string array
        String[] result = new String[nodes.size()];
        if (nodes.size() > 0) {
            for (int loop = 0; loop < nodes.size(); loop++)
                result[loop] = (String)nodes.elementAt(loop);
        }

        return result;
    }

    public byte[] getImageFromUrl(String url) {
        DataInputStream is = null;
        HttpConnection hc = null;
        byte[] img = null;

        try {
            hc = (HttpConnection)Connector.open(url);
            // If we've got a connection?
            if (hc.getResponseCode() == HttpConnection.HTTP_OK) {
                // Open the stream
                is = new DataInputStream(hc.openInputStream());
                // How big is the file?
                int len = (int)hc.getLength();
                byte[] data = null;
                if (len != -1) {
                    // Create a byte array that size
                    data = new byte[len];
                    // Read in the file
                    is.readFully(data);
                } else {
                    // If content length is not given, read in chunks.
                    int chunkSize = 512;
                    int index = 0;
                    int readLength = 0;
                    data = new byte[chunkSize];
                    do {
                        if (data.length < index + chunkSize) {
                            byte[] newData = new byte[index + chunkSize];
                            System.arraycopy(data, 0, newData, 0, data.length);
                            data = newData;
                        }
                        readLength = is.read(data, index, chunkSize);
                        index += readLength;
                    } while (readLength == chunkSize);
                    len = index;
                }
                // Create an image from the raw data
                img = data;
            }
        } catch (Exception e) {
            System.out.println("IO Exception+"+e);
        } finally {
            if (is != null) {
                try { is.close(); }
                catch (Exception e) { }
            }
            if (hc != null) {
                try { hc.close(); }
                catch (Exception e) { }
            }
        }

        return img;
    }

    public void popolaGiorni() {
        calendar = Calendar.getInstance();
        calendar.setTime(new Date());

        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH)+1;
        int day = calendar.get(Calendar.DAY_OF_MONTH);

        String stYear = year+"";
        String stMonth = month + "";
        String stDay = day + "";
        if (stMonth.length() == 1) stMonth = "0"+stMonth;
        if (stDay.length() == 1) stDay = "0"+stDay;

        aaaammggOggi = stYear+stMonth+stDay;

        int j = 0;
        /* Testa se si deve saltare "sino alle 24 di oggi"*/
        if (aaaammggWeb.equals(aaaammggOggi)) j = 0;
        else j = 1;

        for (int i = j; i < giorniArray.length; i++) {
            if (giorniArray[i] == null) break;
            choiceGiorni.append(giorniArray[i].giorno, null);
        }

    }

    public void makeFrmMain() {
        choiceGiorni = new ChoiceGroup("Seleziona il giorno delle previsioni", 
                                 Choice.EXCLUSIVE);
                                 //Choice.MULTIPLE);
        lblCopyright = new StringItem(TITLE+" v "+VERSION+"\n", "By "+AUTHOR);
        lblEmissione = new StringItem("Bollettino emesso:\n", dataEmissione);
        
        btnExitMain = new Command("Esci", Command.EXIT, 1);
        btnPrevisioni = new Command("Previsioni", Command.SCREEN,2);
        frmMain = new Form(TITLE);
        frmMain.append(lblCopyright);
        frmMain.append(choiceGiorni);
        frmMain.append(lblEmissione);

        frmMain.addCommand(btnPrevisioni);
        frmMain.addCommand(btnExitMain);
    }

    public void makeFrmSplash() {
        btnExitSplash = new Command("Esci", Command.EXIT, 1);
        btnShowMain = new Command("Bollettino", Command.SCREEN,2);
        frmSplash = new Form(TITLE);
        frmSplash.append(new StringItem(TITLE+" v "+VERSION+"\n", "By "+AUTHOR));

        frmSplash.addCommand(btnExitSplash);
        frmSplash.addCommand(btnShowMain);
    }

    public void makeFrmPrevisioni() {
        frmPrevisioni = new Form("Previsioni");
        btnBackMain = new Command("Indietro", Command.BACK, 1);
        btnViewImage = new Command("Immagine", Command.SCREEN, 2);
        lblPrevisione = new StringItem(PREVISIONE, "");
        frmPrevisioni.append(lblPrevisione);

        frmPrevisioni.addCommand(btnBackMain);
    }

    public void makeFrmImage() {
        frmImage = new Form("Immagine");
        btnBackPrevisioni = new Command("Indietro", Command.BACK, 1);
        try {
            Image logo = Image.createImage("/MeteoArpav.png");
            imgItem = new ImageItem("", logo, ImageItem.LAYOUT_CENTER, "logo");
            indImgItem = frmImage.append(imgItem);
        } catch (Exception e) {}

        frmImage.addCommand(btnBackPrevisioni);
    }

    public void showFrmSplash() {
        frmSplash.setCommandListener(this);
        try {
            Image logo = Image.createImage("/logo_arpav.png");
            frmSplash.append(new ImageItem("", logo, ImageItem.LAYOUT_CENTER, "logo"));
        } catch (Exception e) {}
        display.setCurrent(frmSplash);
    }

    public void showFrmMain() {
        netState = 0;
        frmMain.setCommandListener(this);
        display.setCurrent(frmMain);
    }

    public void showFrmPrevisioni() {
        frmPrevisioni.setCommandListener(this);
        display.setCurrent(frmPrevisioni);
    }

    public void showFrmImage() {
        frmImage.setCommandListener(this);
        display.setCurrent(frmImage);
    }

    public void startApp() {
    }

    public void pauseApp() { 
    }

    public void destroyApp(boolean unconditional) { 
    }

    public String replace_all_space(String s) {
        StringBuffer n = new StringBuffer();

        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            switch(c) {
            case ' ':
              n.append("%20");
              break;

            default:
              n.append(c);
            }
        }
        return n.toString(); 
    }

    public String replace_all_IMG_TAG(String s) {
        StringBuffer n = new StringBuffer();

        int pos = s.indexOf("IMG_");
        n.append(s.substring(0, pos));

        aaaammggImage = s.substring(pos+4, pos+12);
        return n.toString(); 
    }


    public void commandAction(Command command, Displayable displayable) {
        if (command == btnPrevisioni) {
            boolean picks[] = new boolean[choiceGiorni.size()];
            choiceGiorni.getSelectedFlags(picks);
            for (int i = 0; i < picks.length; i++) {
                if (picks[i]) giornoSelezionato = choiceGiorni.getString(i);
            }

            String strNoTag = "Nessuna previsione disponibile";

            for (int i = 0; i < giorniArray.length; i++) {
                if (giorniArray[i] == null) break;

                if (giorniArray[i].giorno.equals(giornoSelezionato)) {
                    strNoTag = giorniArray[i].previsione;
                    aaaammggImage = giorniArray[i].img;
                    if (aaaammggImage != null) {
                        frmPrevisioni.addCommand(btnViewImage);
                        boolViewImage = true;
                    }
                }
            }

            lblPrevisione.setLabel(PREVISIONE);
            lblPrevisione.setText(strNoTag);
            //getUrlImage = "http://vega/j2me_arpav_img.php?giorno="+aaaammggImage+"&version="+VERSION;
            getUrlImage = "http://zanac.homelinux.net/j2me_arpav_img.php?giorno="+aaaammggImage+"&version="+VERSION;

            showFrmPrevisioni();
        } else if (command == btnViewImage) {
            frmPrevisioni.removeCommand(btnViewImage);
            boolViewImage = false;
            netState = 2;
            thread = new Thread(this);
            thread.start();
        } else if ((command == btnExitMain)
                || (command == btnExitSplash)) {
            thread = null;
            destroyApp(false);
            notifyDestroyed();
        } else if (command == btnShowMain) {
            netState = 1;
            frmSplash.removeCommand(btnShowMain);
            //getUrl = "http://vega/j2me_arpav_new2.php?version="+VERSION;
            getUrl = "http://zanac.homelinux.net/j2me_arpav_new2.php?version="+VERSION;
            thread = new Thread(this);
            thread.start();
            thread = null;
        } else if (command == btnBackMain) {
            thread = null;
            if (boolViewImage) {
                frmPrevisioni.removeCommand(btnViewImage);
                boolViewImage = false;
            }
            showFrmMain();
        } else if (command == btnBackPrevisioni) {
            thread = null;
            frmPrevisioni.addCommand(btnViewImage);
            boolViewImage = true;
            showFrmPrevisioni();
        }
    }
    
    private boolean getPrevisioneFromUrl(String url) {
        HttpConnection hc = null;
        DataInputStream in = null;

        try {
            hc = (HttpConnection)Connector.open(url);
            int length = (int)hc.getLength();
            byte[] data = null;

            if (length != -1) {
                // Fully Read exactly Content-Length bytes
                // DEBUG: System.out.println("Content-Length: " + len);
                data = new byte[length];
                in = new DataInputStream(hc.openInputStream());
                in.readFully(data); 
            } else {
                // If content length is not given, read in chunks.
                int chunkSize = 512;
                int index = 0;
                int readLength = 0;
                in = new DataInputStream(hc.openInputStream());
                data = new byte[chunkSize];
                do {
                    if (data.length < index + chunkSize) {
                        byte[] newData = new byte[index + chunkSize];
                        System.arraycopy(data, 0, newData, 0, data.length);
                        data = newData;
                    }
                    readLength = in.read(data, index, chunkSize);
                    index += readLength;
                } while (readLength == chunkSize);
                length = index; 
            }

            if (!parseDataFromServer(new String(data))) {
                show_alert ("Http Error", "Sito arpav non raggiungibile", 1, 3000,  frmSplash);
                return false;
            }
            return true;
        } catch (IOException ex) {
            System.out.println("Exception reading from http");
            showFrmMain();
            if (hc != null) {
              try {
                String s = hc.getResponseMessage();
                if (s == null) s = "No Response message";
              } catch (IOException e) {
                ex.printStackTrace();
                String s = ex.toString();
                if (s == null) s = ex.getClass().getName();
                show_alert ("Http Error", s, 1, 3000,  frmSplash);
                return false;
              }
            } else {
                show_alert ("Http Error", "Sito Arpav non raggiungibile", 1, 3000,  frmSplash);
                return false;
            }
        }
        return false;
    }

    //Visualizza i messaggi d'errore
    public void show_alert (String Title, String Message, int Type, int TimeOut, Form Form){
        AlertType alertType;

        switch (Type)  {
            default:
            case 0: //CONFERMA
              alertType = AlertType.CONFIRMATION;
            break;
            case 1: //ERRORE
              alertType = AlertType.ERROR;
            break;
            case 2: //INFO
              alertType = AlertType.INFO;
            break;  
        }
        Alert alert = new Alert(Title, Message, null, alertType);
        alert.setTimeout(TimeOut);
        display.setCurrent(alert, Form);
    }
}
